using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace ManyToManyHierarchicalGrid
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 24);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(672, 360);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(704, 406);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridDataBoundGrid1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private int numRowsA = 100;
		private int numRowsB = 300;

		private int numColsB = 5;

		private DataTable tableA;
		private DataTable tableB;
		private DataTable table_A_B;

		GridHierarchyLevel level0;
		GridHierarchyLevel level1;

		private string[] unBoundColumnNames;
        
		private void Form1_Load(object sender, System.EventArgs e)
		{
			//The idea is to use a relation between parent table TableA and child table table_A_B
			//but instead of displaying fields from table_A_B, display as unbound columns, fields
			//from tableB. This requires handling Model.QuerySaveInfo and Model.SaveCellInfo to 
			//manage the unbound columns.

			//get the tables somehow...
			this.tableA = GetTable("Company", numRowsA); //primary table 1
			this.tableB = GetTable("Vendor", numRowsB); //primary table 2
			this.table_A_B = GetTable_A_B(); //table that relates A records to B records

			//add them to a dataset to define a relation 
			DataSet ds = new DataSet("myDataSet");
			ds.Tables.AddRange(new DataTable[]{this.tableA, this.table_A_B});
			ds.Relations.Add(new DataRelation("tableA_To_table_A_B", this.tableA.Columns["companyID"], this.table_A_B.Columns["companyID"])); 

			//set up unbound columns
			unBoundColumnNames = new string[numColsB - 1];
			unBoundColumnNames[0] = "Vendor Name";
			unBoundColumnNames[1] = "Vendor Description";
			unBoundColumnNames[2] = "Vendor Address";
			unBoundColumnNames[3] = "Vendor Zip";

			//define hiearchical grid
			this.gridDataBoundGrid1.DataSource = ds;
			this.gridDataBoundGrid1.DataMember = this.tableA.TableName;

			level0 = this.gridDataBoundGrid1.Binder.RootHierarchyLevel;
			level0.LayoutColumns(new string[] {"companyID", "companyName", "companyDescription", "-", "-"});
			level0.GridBoundColumns["companyName"].HeaderText = "CompanyName";
			level0.GridBoundColumns["companyDescription"].HeaderText = "CompanyDescription";
			level0.RowStyle.BackColor = Color.LightGoldenrodYellow;

			level1 = this.gridDataBoundGrid1.Binder.AddRelation("tableA_To_table_A_B");
			level1.LayoutColumns(new string[] {"vendorID", unBoundColumnNames[0], unBoundColumnNames[1], unBoundColumnNames[2], unBoundColumnNames[3]});
			level1.RowStyle.BackColor = Color.LightBlue;
			
			//subscribe to teh events
			this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(gridModel_QueryCellInfo);
			//needed if you want to edit this grid...
			//this.gridDataBoundGrid1.Model.SaveCellInfo += new GridSaveCellInfoEventHandler(gridModel_SaveCellInfo);

			//hide the ID column
			this.gridDataBoundGrid1.AllowResizeToFit = false;
			this.gridDataBoundGrid1.Model.ColWidths.ResizeToFit(GridRangeInfo.Row(1), GridResizeToFitOptions.IncludeHeaders);
			this.gridDataBoundGrid1.Model.ColWidths["companyID"] = 0;
			
			

		}

		private void gridModel_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 2)
			{
				if(e.RowIndex == 1) //tableB header row
				{

					e.Style.Text = unBoundColumnNames[e.ColIndex - 3]; //-3 because skip header, skip +/-, skip first hidden column
				}
				else if(e.RowIndex > 1)
				{//field in record
					GridBoundRecordState rs = this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(e.RowIndex);
					if(rs.LevelIndex == 1)  
					{ //unbound level
						this.tableB.DefaultView.RowFilter = string.Format("[vendorID] = '{0}'", this.gridDataBoundGrid1[e.RowIndex, 2].Text);
						DataRowView drv = this.tableB.DefaultView[0];
						e.Style.CellValue = drv[e.ColIndex - 2]; // grid col 1 and 2 from tableB, skip col 0
					}
				}
			}
		}

		private void gridModel_SaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			//need to handle if you want to edit this grid directly...
		}

		private DataTable GetTable(string name, int numRows)
		{
			DataTable dt = new DataTable("Table" + name.ToUpper());

			
			dt.Columns.Add(new DataColumn(name.ToLower() + "ID")); //lower case p
			dt.Columns.Add(new DataColumn(name.ToLower() + "Name"));
			dt.Columns.Add(new DataColumn(name.ToLower() + "Description"));
			if(name == "Vendor")
			{
				dt.Columns.Add(new DataColumn(name.ToLower() + "Address"));
				dt.Columns.Add(new DataColumn(name.ToLower() + "Zip"));
			}

			for(int i = 0; i < numRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format(name.ToLower() + "Name{0}", i);
				dr[2] = string.Format(name.ToLower() + "Desc{0}", i);
				if(name == "Vendor")
				{
					dr[3] = string.Format(name.ToLower() + "Address{0}", i);
					dr[4] = string.Format(name.ToLower() + "Zip{0}", i);
				
				}
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetTable_A_B()
		{
			DataTable dt = new DataTable("Table_A_B");

			
			dt.Columns.Add(new DataColumn("companyID"));  
			dt.Columns.Add(new DataColumn("vendorID"));
			
			//randomly assign some table B entries for each table A entry
			Random r = new Random();
			for(int i = 0; i < numRowsA; ++i)
			{
				int numB = r.Next(15);
				for(int j = 0; j < numB; ++j)
				{
					DataRow dr = dt.NewRow();
					dr["companyID"] = i.ToString();
					dr["vendorID"] = r.Next(this.numRowsB);;
					dt.Rows.Add(dr);
				}
			}

			return dt;
		}		
	}
}
