
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports Syncfusion.Windows.Forms.Grid


 
Public Class Form1
   Inherits System.Windows.Forms.Form
   Private gridDataBoundGrid1 As Syncfusion.Windows.Forms.Grid.GridDataBoundGrid
   
   Private components As System.ComponentModel.Container = Nothing
   
   
   Public Sub New()
       
      InitializeComponent()
   End Sub 'New
    
    
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose

#Region "Windows Form Designer generated code"

    '/ <summary>
    '/ Required method for Designer support - do not modify
    '/ the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Me.gridDataBoundGrid1 = New Syncfusion.Windows.Forms.Grid.GridDataBoundGrid()
        CType(Me.gridDataBoundGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        ' 
        ' gridDataBoundGrid1
        ' 
        Me.gridDataBoundGrid1.AllowDragSelectedCols = True
        Me.gridDataBoundGrid1.Anchor = System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left Or System.Windows.Forms.AnchorStyles.Right
        Me.gridDataBoundGrid1.Location = New System.Drawing.Point(16, 24)
        Me.gridDataBoundGrid1.Name = "gridDataBoundGrid1"
        Me.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus
        Me.gridDataBoundGrid1.Size = New System.Drawing.Size(672, 360)
        Me.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick
        Me.gridDataBoundGrid1.TabIndex = 0
        Me.gridDataBoundGrid1.Text = "gridDataBoundGrid1"
        ' 
        ' Form1
        ' 
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(704, 406)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.gridDataBoundGrid1})
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.gridDataBoundGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
    End Sub 'InitializeComponent 
#End Region


     

    Private numRowsA As Integer = 100
    Private numRowsB As Integer = 300

    Private numColsB As Integer = 5

    Private tableA As DataTable
    Private tableB As DataTable
    Private table_A_B As DataTable

    Private level0 As GridHierarchyLevel
    Private level1 As GridHierarchyLevel

    Private unBoundColumnNames() As String


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'The idea is to use a relation between parent table TableA and child table table_A_B
        'but instead of displaying fields from table_A_B, display as unbound columns, fields
        'from tableB. This requires handling Model.QuerySaveInfo and Model.SaveCellInfo to 
        'manage the unbound columns.
        'get the tables somehow...
        Me.tableA = GetTable("Company", numRowsA) 'primary table 1
        Me.tableB = GetTable("Vendor", numRowsB) 'primary table 2
        Me.table_A_B = GetTable_A_B() 'table that relates A records to B records
        'add them to a dataset to define a relation 
        Dim ds As New DataSet("myDataSet")
        ds.Tables.AddRange(New DataTable() {Me.tableA, Me.table_A_B})
        ds.Relations.Add(New DataRelation("tableA_To_table_A_B", Me.tableA.Columns("companyID"), Me.table_A_B.Columns("companyID")))

        'set up unbound columns
        unBoundColumnNames = New String(numColsB - 2) {}
        unBoundColumnNames(0) = "Vendor Name"
        unBoundColumnNames(1) = "Vendor Description"
        unBoundColumnNames(2) = "Vendor Address"
        unBoundColumnNames(3) = "Vendor Zip"

        'define hiearchical grid
        Me.gridDataBoundGrid1.DataSource = ds
        Me.gridDataBoundGrid1.DataMember = Me.tableA.TableName

        level0 = Me.gridDataBoundGrid1.Binder.RootHierarchyLevel
        level0.LayoutColumns(New String() {"companyID", "companyName", "companyDescription", "-", "-"})
        level0.GridBoundColumns("companyName").HeaderText = "CompanyName"
        level0.GridBoundColumns("companyDescription").HeaderText = "CompanyDescription"
        level0.RowStyle.BackColor = Color.LightGoldenrodYellow

        level1 = Me.gridDataBoundGrid1.Binder.AddRelation("tableA_To_table_A_B")
        level1.LayoutColumns(New String() {"vendorID", unBoundColumnNames(0), unBoundColumnNames(1), unBoundColumnNames(2), unBoundColumnNames(3)})
        level1.RowStyle.BackColor = Color.LightBlue

        'subscribe to teh events
        AddHandler Me.gridDataBoundGrid1.Model.QueryCellInfo, AddressOf gridModel_QueryCellInfo
        'needed if you want to edit this grid...
        'this.gridDataBoundGrid1.Model.SaveCellInfo += new GridSaveCellInfoEventHandler(gridModel_SaveCellInfo);
        'hide the ID column
        Me.gridDataBoundGrid1.AllowResizeToFit = False
        Me.gridDataBoundGrid1.Model.ColWidths.ResizeToFit(GridRangeInfo.Row(1), GridResizeToFitOptions.IncludeHeaders)
        'Me.gridDataBoundGrid1.Model.ColWidths("companyID") = 0
    End Sub 'Form1_Load




    Private Sub gridModel_QueryCellInfo(ByVal sender As Object, ByVal e As GridQueryCellInfoEventArgs)
        If e.ColIndex > 2 Then
            If e.RowIndex = 1 Then 'tableB header row

                e.Style.Text = unBoundColumnNames((e.ColIndex - 3)) '-3 because skip header, skip +/-, skip first hidden column
            ElseIf e.RowIndex > 1 Then
                'field in record
                Dim rs As GridBoundRecordState = Me.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(e.RowIndex)
                If rs.LevelIndex = 1 Then
                    'unbound level
                    Me.tableB.DefaultView.RowFilter = String.Format("[vendorID] = '{0}'", Me.gridDataBoundGrid1(e.RowIndex, 2).Text)
                    Dim drv As DataRowView = Me.tableB.DefaultView(0)
                    e.Style.CellValue = drv((e.ColIndex - 2)) ' grid col 1 and 2 from tableB, skip col 0
                End If
            End If
        End If
    End Sub 'gridModel_QueryCellInfo


    Private Sub gridModel_SaveCellInfo(ByVal sender As Object, ByVal e As GridSaveCellInfoEventArgs)
    End Sub 'gridModel_SaveCellInfo

    'need to handle if you want to edit this grid directly...

    Private Function GetTable(ByVal name As String, ByVal numRows As Integer) As DataTable
        Dim dt As New DataTable("Table" + name.ToUpper())


        dt.Columns.Add(New DataColumn(name.ToLower() + "ID")) 'lower case p
        dt.Columns.Add(New DataColumn(name.ToLower() + "Name"))
        dt.Columns.Add(New DataColumn(name.ToLower() + "Description"))
        If name = "Vendor" Then
            dt.Columns.Add(New DataColumn(name.ToLower() + "Address"))
            dt.Columns.Add(New DataColumn(name.ToLower() + "Zip"))
        End If

        Dim i As Integer

        While i < numRows
            Dim dr As DataRow = dt.NewRow()
            dr(0) = i.ToString()
            dr(1) = String.Format(name.ToLower() + "Name{0}", i)
            dr(2) = String.Format(name.ToLower() + "Desc{0}", i)
            If name = "Vendor" Then
                dr(3) = String.Format(name.ToLower() + "Address{0}", i)
                dr(4) = String.Format(name.ToLower() + "Zip{0}", i)
            End If
            dt.Rows.Add(dr)
            i += 1
        End While

        Return dt
    End Function 'GetTable


    Private Function GetTable_A_B() As DataTable
        Dim dt As New DataTable("Table_A_B")


        dt.Columns.Add(New DataColumn("companyID"))
        dt.Columns.Add(New DataColumn("vendorID"))

        'randomly assign some table B entries for each table A entry
        Dim r As New Random()
        Dim i As Integer

        While i < numRowsA
            Dim numB As Integer = r.Next(15)
            Dim j As Integer = 0
            While j < numB
                Dim dr As DataRow = dt.NewRow()
                dr("companyID") = i.ToString()
                dr("vendorID") = r.Next(Me.numRowsB)
                dt.Rows.Add(dr)
                j += 1
            End While
            i += 1
        End While

        Return dt
    End Function 'GetTable_A_B
End Class 'Form1 
